#include "stdio.h"

struct SNo
{
   int chave;
   SNo * prox;
};

void Push(int chave, SNo * * Topo);
int Pop(SNo * * Topo);

SNo * Topo1 = NULL; /* Topo aponta para nada */
SNo * Topo2 = NULL; /* Topo aponta para nada */

int main()
{
   int x;
   bool paridade = true;
 
  
   printf("Entre com o nmero ou -1 para terminar..:");
   scanf("%i",&x);  
   while( x != -1 ) {
   
      if(paridade) Push(x, &Topo1);
      else Push(x, &Topo2);
      paridade = !paridade;
      printf("Entre com o nmero ou -1 para terminar..:");
      scanf("%i",&x);  
   }   
 
   printf("\nPilha 1 : ");
   
   x = Pop(&Topo1);
   while( x != -1 ) {
      printf("%i ",x);   
      x = Pop(&Topo1);
   }

   printf("\nPilha 2 : ");

   x = Pop(&Topo2);
   while( x != -1 ) {
      printf("%i ",x);   
      x = Pop(&Topo2);
   }

   printf("\n");

}

void Push(int chave, SNo * * Topo)
{
   SNo * No;
   
   No = new SNo;
 
   printf("Pushing...%i\n",chave);
   
   if(No==NULL)
   {
   	printf("Overflow");
   }
   else
   {
      No->chave = chave;
      No->prox = *Topo;
      
      *Topo = No;
   }
}

int Pop(SNo * * Topo)
{
   int chave;
   SNo * temp;
   
   
   if((*Topo)==NULL)
   {
      return(-1);
   }
   else
   {
   
      chave = (*Topo)->chave;
      temp = (*Topo)->prox;
      delete (*Topo);
      (*Topo) = temp;
      
      return(chave);
   }  	
}



